SystemOrganization addCategory: #'XPath-GTExtensions'!
SystemOrganization addCategory: 'XPath-GTExtensions-Highlighting'!
SystemOrganization addCategory: 'XPath-GTExtensions-Highlighting-AST'!
SystemOrganization addCategory: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathASTStepNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:28'!
treeViewChildren
	^ self hasPredicates
		ifTrue: [self predicates copyWithFirst: self nodeTest]
		ifFalse: [Array with: self nodeTest]! !

!XPathASTElementNodeTestForPrefixAndLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:31'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self localName qualifyWithXMLPrefix: self prefix);
		nextPut: $).! !

!XPathASTElementNodeTestForPrefixNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self prefix;
		nextPut: $).! !

XPathExpressionNodeTestParserHandler subclass: #XPathPositionExpressionNodeTestParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathPositionExpressionNodeTestParserHandler commentStamp: 'monty 4/4/2017 08:05' prior: 0!
This class forwards position handler messages to an XPathPositionExpressionParserHandler.!

!XPathPositionExpressionNodeTestParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/3/2017 18:00'!
handleEndArgumentPosition: aPosition
	expressionParserHandler handleEndArgumentPosition: aPosition! !

!XPathPositionExpressionNodeTestParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/3/2017 17:35'!
handleEndFunctionCallPosition: aPosition
	expressionParserHandler handleEndFunctionCallPosition: aPosition! !

!XPathPositionExpressionNodeTestParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/3/2017 17:34'!
handleEndNodeTestPosition: aPosition
	expressionParserHandler handleEndNodeTestPosition: aPosition! !

!XPathPositionExpressionNodeTestParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/3/2017 17:59'!
handleStartArgumentPosition: aPosition
	expressionParserHandler handleStartArgumentPosition: aPosition! !

!XPathPositionExpressionNodeTestParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/3/2017 17:34'!
handleStartFunctionCallPosition: aPosition
	expressionParserHandler handleStartFunctionCallPosition: aPosition! !

!XPathPositionExpressionNodeTestParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/3/2017 17:33'!
handleStartNodeTestPosition: aPosition
	expressionParserHandler handleStartNodeTestPosition: aPosition! !

XPathExpressionParserHandler subclass: #XPathPositionExpressionParserHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathPositionExpressionParserHandler commentStamp: 'monty 3/1/2017 15:14' prior: 0!
This class is a handler for XPathPositionExpressionParsers.!

XPathPositionExpressionParserHandler subclass: #XPathHighlightingPositionExpressionParserHandler
	instanceVariableNames: 'highlighter expressionSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathHighlightingPositionExpressionParserHandler commentStamp: 'monty 3/1/2017 15:14' prior: 0!
This class is a highlighting handler for XPathPositionExpressionParsers that returns the parsed expression source as a highlighted Text object.!

!XPathHighlightingPositionExpressionParserHandler class methodsFor: 'instance creation' stamp: 'monty 3/1/2017 15:16'!
expressionSource: anExpression
	^ self new expressionSource: anExpression! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'converting' stamp: 'monty 3/1/2017 15:17'!
asHighlightedText
	| text |

	text := self expressionSource asText.
	highlighter highlightText: text.
	^ text.! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'converting' stamp: 'monty 3/2/2017 06:03'!
asHighlightedTextWithRemainderColored: aTextColor startingAt: aPosition
	| text |

	text := self asHighlightedText.
	highlighter
		highlightText: text
		withColor: aTextColor
		startingAt: aPosition.
	^ text.! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/2/2017 06:29'!
encoding
	^ ''! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/1/2017 15:16'!
expressionSource
	^ expressionSource ifNil: [expressionSource := '']! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/1/2017 15:16'!
expressionSource: anExpressionSourceString
	expressionSource := anExpressionSourceString! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 23:31'!
handleEndArgumentPosition: aPosition
	highlighter startFunctionCallHighlightPosition: aPosition + 1! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleEndAxisPosition: aPosition
	highlighter endAxisHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleEndFunctionCallPosition: aPosition
	highlighter endFunctionCallHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleEndNodeTestPosition: aPosition
	highlighter endNodeTestHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleEndNumberLiteralPosition: aPosition
	highlighter endNumberLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:26'!
handleEndOperatorPosition: aPosition
	highlighter endOperatorHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2017 14:49'!
handleEndParsing
	self parsingResult: self asHighlightedText! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 23:59'!
handleEndPredicatePosition: aPosition
	highlighter
		decrementPredicateColorLevel;
		startPredicateHighlightPosition: aPosition;
		endPredicateHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleEndStringLiteralPosition: aPosition
	highlighter endStringLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:29'!
handleEndVariableReferencePosition: aPosition
	highlighter endVariableReferenceHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 23:32'!
handleStartArgumentPosition: aPosition
	highlighter endFunctionCallHighlightPosition: aPosition - 1! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleStartAxisPosition: aPosition
	highlighter startAxisHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleStartFunctionCallPosition: aPosition
	highlighter startFunctionCallHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:24'!
handleStartNodeTestPosition: aPosition
	highlighter startNodeTestHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleStartNumberLiteralPosition: aPosition
	highlighter startNumberLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:26'!
handleStartOperatorPosition: aPosition
	highlighter startOperatorHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling' stamp: 'monty 3/1/2017 10:23'!
handleStartParsing
	highlighter := XPathExpressionHighlighter new! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 23:59'!
handleStartPredicatePosition: aPosition
	highlighter
		startPredicateHighlightPosition: aPosition;
		endPredicateHighlightPosition: aPosition;
		incrementPredicateColorLevel! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:25'!
handleStartStringLiteralPosition: aPosition
	highlighter startStringLiteralHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 10:29'!
handleStartVariableReferencePosition: aPosition
	highlighter startVariableReferenceHighlightPosition: aPosition! !

!XPathHighlightingPositionExpressionParserHandler methodsFor: 'accessing' stamp: 'monty 3/1/2017 18:31'!
highlighter
	^ highlighter! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 23:30'!
handleEndArgumentPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleEndAxisPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleEndFunctionCallPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleEndNodeTestPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleEndNumberLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleEndOperatorPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleEndPredicatePosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:20'!
handleEndStringLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:23'!
handleEndVariableReferencePosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 4/1/2017 23:29'!
handleStartArgumentPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleStartAxisPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:17'!
handleStartFunctionCallPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleStartNodeTestPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleStartNumberLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:18'!
handleStartOperatorPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:19'!
handleStartPredicatePosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:20'!
handleStartStringLiteralPosition: aPosition! !

!XPathPositionExpressionParserHandler methodsFor: 'handling - positions' stamp: 'monty 3/1/2017 09:23'!
handleStartVariableReferencePosition: aPosition! !

!XPathASTElementNodeTestForLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self localName;
		nextPut: $).! !

!XPathASTUnaryOperatorExpressionNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 03:13'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self operatorName;
		nextPut: $).! !

!XPathASTVariableReferenceNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 03:14'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathASTElementNodeTestForNamespaceURIAndLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self localName expandWithXMLNamespaceURI: self namespaceURI);
		nextPut: $).! !

!XPathASTFilterExpressionLocationPathNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:30'!
treeViewChildren
	^ self hasSteps
		ifTrue: [self steps copyWithFirst: self expression]
		ifFalse: [super treeViewChildren]! !

!XPathASTFilterExpressionNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:31'!
treeViewChildren
	^ self hasPredicates
		ifTrue: [self predicates copyWithFirst: self expression]
		ifFalse: [super treeViewChildren]! !

!XMLDeclarationNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/6/2017 17:50'!
supportsXPathEvaluator
	^ false! !

XMLHighlighter subclass: #XPathExpressionHighlighter
	instanceVariableNames: 'axisColor nodeTestColor predicateColors predicateColorLevel operatorColor functionCallColor stringLiteralColor numberLiteralColor variableReferenceColor axisHighlight nodeTestHighlight predicateHighlightStack operatorHighlight functionCallHighlightStack stringLiteralHighlight numberLiteralHighlight variableReferenceHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting'!

!XPathExpressionHighlighter commentStamp: 'monty 3/31/2017 02:03' prior: 0!
This class is a highlighter to highlight XPath expression Text objects using XMLHighlights.!

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:01'!
axisColor
	^ axisColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:01'!
axisColor: aTextColor
	axisColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/2/2017 00:40'!
decrementPredicateColorLevel
	(predicateColorLevel := predicateColorLevel - 1) >= 1
		ifFalse: [
			"wrap around to the last color"
			predicateColorLevel := self maxPredicateColorLevel]! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:27'!
defaults
	^ XPathExpressionHighlightDefaults! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:20'!
endAxisHighlightPosition: aPosition
	self
		endHighlight: axisHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:50'!
endFunctionCallHighlightPosition: aPosition
	self
		endHighlight: functionCallHighlightStack removeLast
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:20'!
endNodeTestHighlightPosition: aPosition
	self
		endHighlight: nodeTestHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:21'!
endNumberLiteralHighlightPosition: aPosition
	self
		endHighlight: numberLiteralHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:26'!
endOperatorHighlightPosition: aPosition
	self
		endHighlight: operatorHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:50'!
endPredicateHighlightPosition: aPosition
	self
		endHighlight: predicateHighlightStack removeLast
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:21'!
endStringLiteralHighlightPosition: aPosition
	self
		endHighlight: stringLiteralHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:29'!
endVariableReferenceHighlightPosition: aPosition
	self
		endHighlight: variableReferenceHighlight
		position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
functionCallColor
	^ functionCallColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
functionCallColor: aTextColor
	functionCallColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/2/2017 00:40'!
incrementPredicateColorLevel
	(predicateColorLevel := predicateColorLevel + 1) <= self maxPredicateColorLevel
		ifFalse: [
			"wrap around to the first color"
			predicateColorLevel := 1]! !

!XPathExpressionHighlighter methodsFor: 'initialization' stamp: 'monty 4/3/2017 18:38'!
initializeColors
	super initializeColors.
	self
		initializePredicateColors;
		axisColor: self defaults defaultAxisColor;
		nodeTestColor: self defaults defaultNodeTestColor;
		predicateLevelOneColor: self defaults defaultPredicateLevelOneColor;
		predicateLevelTwoColor: self defaults defaultPredicateLevelTwoColor;
		predicateLevelThreeColor: self defaults defaultPredicateLevelThreeColor;
		predicateLevelFourColor: self defaults defaultPredicateLevelFourColor;
		predicateLevelFiveColor: self defaults defaultPredicateLevelFiveColor;
		predicateLevelSixColor: self defaults defaultPredicateLevelSixColor;
		operatorColor: self defaults defaultOperatorColor;
		functionCallColor: self defaults defaultFunctionCallColor;
		stringLiteralColor: self defaults defaultStringLiteralColor;
		numberLiteralColor: self defaults defaultNumberLiteralColor;
		variableReferenceColor: self defaults defaultVariableReferenceColor.! !

!XPathExpressionHighlighter methodsFor: 'initialization' stamp: 'monty 4/1/2017 23:51'!
initializeHighlights
	super initializeHighlights.

	predicateHighlightStack := OrderedCollection new.
	functionCallHighlightStack := OrderedCollection new.! !

!XPathExpressionHighlighter methodsFor: 'initialization' stamp: 'monty 4/2/2017 00:01'!
initializePredicateColors
	predicateColors := Array new: self maxPredicateColorLevel.
	predicateColorLevel := 1.! !

!XPathExpressionHighlighter methodsFor: 'private' stamp: 'monty 4/3/2017 18:38'!
maxPredicateColorLevel
	^ 6! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:01'!
nodeTestColor
	^ nodeTestColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
nodeTestColor: aTextColor
	nodeTestColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
numberLiteralColor
	^ numberLiteralColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
numberLiteralColor: aTextColor
	numberLiteralColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
operatorColor
	^ operatorColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:02'!
operatorColor: aTextColor
	operatorColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'private' stamp: 'monty 4/2/2017 00:38'!
predicateColor
	^ predicateColors at: predicateColorLevel! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:35'!
predicateLevelFiveColor
	^ predicateColors at: 5! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:35'!
predicateLevelFiveColor: aTextColor
	predicateColors
		at: 5
		put: aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:35'!
predicateLevelFourColor
	^ predicateColors at: 4! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:35'!
predicateLevelFourColor: aTextColor
	predicateColors
		at: 4
		put: aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:34'!
predicateLevelOneColor
	^ predicateColors at: 1! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:34'!
predicateLevelOneColor: aTextColor
	predicateColors
		at: 1
		put: aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:38'!
predicateLevelSixColor
	^ predicateColors at: 6! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:38'!
predicateLevelSixColor: aTextColor
	predicateColors
		at: 6
		put: aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:35'!
predicateLevelThreeColor
	^ predicateColors at: 3! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:35'!
predicateLevelThreeColor: aTextColor
	predicateColors
		at: 3
		put: aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:34'!
predicateLevelTwoColor
	^ predicateColors at: 2! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:34'!
predicateLevelTwoColor: aTextColor
	predicateColors
		at: 2
		put: aTextColor! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:17'!
startAxisHighlightPosition: aPosition
	axisHighlight :=
		self
			newHighlightColor: self axisColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:13'!
startFunctionCallHighlightPosition: aPosition
	functionCallHighlightStack addLast:
		(self
			newHighlightColor: self functionCallColor
			position: aPosition)! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:17'!
startNodeTestHighlightPosition: aPosition
	nodeTestHighlight :=
		self
			newHighlightColor: self nodeTestColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:19'!
startNumberLiteralHighlightPosition: aPosition
	numberLiteralHighlight :=
		self
			newHighlightColor: self numberLiteralColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:18'!
startOperatorHighlightPosition: aPosition
	operatorHighlight :=
		self
			newHighlightColor: self operatorColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 4/2/2017 00:38'!
startPredicateHighlightPosition: aPosition
	predicateHighlightStack addLast:
		(self
			newHighlightColor: self predicateColor
			position: aPosition)! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:18'!
startStringLiteralHighlightPosition: aPosition
	stringLiteralHighlight :=
		self
			newHighlightColor: self stringLiteralColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 3/1/2017 10:19'!
startVariableReferenceHighlightPosition: aPosition
	variableReferenceHighlight :=
		self
			newHighlightColor: self variableReferenceColor
			position: aPosition! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
stringLiteralColor
	^ stringLiteralColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:03'!
stringLiteralColor: aTextColor
	stringLiteralColor := aTextColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
variableReferenceColor
	^ variableReferenceColor! !

!XPathExpressionHighlighter methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:04'!
variableReferenceColor: aTextColor
	variableReferenceColor := aTextColor! !

!XPathASTAttributeNodeTestForLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self localName;
		nextPut: $).! !

!XPathASTNodeWithExpression methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:24'!
supportsTreeView
	^ true! !

!XPathASTNodeWithExpression methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:22'!
treeViewChildren
	^ Array with: self expression! !

!XPathASTLiteralNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 03:16'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self asXPathString;
		nextPut: $).! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 15:56'!
errorTextFor: anError
	| errorClassName errorMessage errorText |

	errorClassName := anError class name asString.
	errorMessage := anError messageText.
	errorText :=
		(errorClassName, '
	', errorMessage) asText.
	errorText
		addAttribute: TextColor red
		from: 1
		to: errorText size.
	errorText
		addAttribute: XPathExpressionHighlightDefaults defaultDefaultColor
		from: 1
		to: errorClassName size.
	errorText
		addAttribute: TextEmphasis bold
		from: 1
		to: errorClassName size.
	^ errorText.! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 16:22'!
gtInspectorASTIn: aComposite
	<gtInspectorPresentationOrder: 7>

	| ast astError |

	[ast :=
		(XPathExpressionParser
			on: self expressionSource
			for: XPathASTExpressionParserHandler new) parse]
		on: XPathException
		do: [:error |
			ast := nil.
			astError := error].

	aComposite tree
		title: 'AST';
		display: [{ast}];
		children: [:each | each treeViewChildren];
		format: [:each | each treeViewLabelText];
		when: [ast notNil];
		rootsExpanded.
	aComposite text
		title: 'AST';
		format: [self errorTextFor: astError];
		when: [ast isNil].! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 16:21'!
gtInspectorCompiledIn: aComposite
	<gtInspectorPresentationOrder: 8>

	| block blockError |

	[block := self compiledExpression block]
		on: XPathException
		do: [:error |
			block := nil.
			blockError := error].

	aComposite pharoMethod
		title: 'Compiled';
		display: [block method];
		smalltalkClass: [block method methodClass];
		when: [block notNil].
	aComposite text
		title: 'Compiled';
		format: [self errorTextFor: blockError];
		when: [block isNil].! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 16:30'!
gtInspectorSourceIn: aComposite inContext: aGTInspector
	<gtInspectorPresentationOrder: 6>

	| currentTextStylerDecorator |

	aComposite custom:
		(GLMRubricHighlightedTextPresentation new
			title: 'Source';
			editingMode: [
				currentTextStylerDecorator :=
					GLMXPathHighlighterTextStylerDecorator new.
				GLMHighlighterTextRubEditingMode withStylerDecorator:
					currentTextStylerDecorator];
			display: [self expressionSource];
			withLineNumbers: true;
			act: [:presentation |
				self expressionSource: currentTextStylerDecorator text asString.
				[aGTInspector panes size > 1]
					whileTrue: [aGTInspector removeLastPane].
				aComposite pane update]
				icon: GLMUIThemeExtraIcons glamorousAccept
				on: $s
				entitled: 'Accept';
			act: [:presentation |
				presentation update]
				icon: GLMUIThemeExtraIcons glamorousUndo
				on: $Z
				entitled: 'Revert').! !

!XPath methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 16:21'!
gtInspectorTestsIn: aComposite
	<gtInspectorPresentationOrder: 9>

	| nodeTests nodeTestsError |

	[nodeTests := self compiledExpression nodeTests]
		on: XPathException
		do: [:error |
			nodeTests := nil.
			nodeTestsError := error].

	aComposite list
		title: 'Tests';
		display: [nodeTests];
		when: [nodeTests notNil].
	aComposite text
		title: 'Tests';
		format: [self errorTextFor: nodeTestsError];
		when: [nodeTests isNil].! !

XPathASTSourceWritingNodeVisitor subclass: #XPathHighlightingASTSourceWritingNodeVisitor
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-AST'!

!XPathHighlightingASTSourceWritingNodeVisitor commentStamp: 'monty 3/31/2017 07:31' prior: 0!
This class is a highlighting writing AST visitor that writes the AST as highlighted XPath source code that can be parsed by an XPathExpressionParser or converted to a Text object with #asHighlightedText.!

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'converting' stamp: 'monty 3/31/2017 05:01'!
asHighlightedText
	| text |

	text := self contents asText.
	highlighter highlightText: text.
	^ text.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 4/1/2017 23:20'!
emitArgumentSeparator
	super emitArgumentSeparator.
	highlighter endFunctionCallHighlightPosition: self endPosition.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 3/31/2017 07:26'!
emitAxisName: anAxisNameStringOrCharacter
	highlighter startAxisHighlightPosition: self startPosition.
	super emitAxisName: anAxisNameStringOrCharacter.
	highlighter endAxisHighlightPosition: self endPosition.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 4/3/2017 17:03'!
emitNodeTest: aNodeTest withNameTest: aNameTestString
	highlighter startNodeTestHighlightPosition: self startPosition.
	super
		emitNodeTest: aNodeTest
		withNameTest: aNameTestString.
	highlighter endNodeTestHighlightPosition: self endPosition.
	^ aNodeTest.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 3/31/2017 07:27'!
emitOperatorName: anOperatorNameStringOrCharacter
	highlighter startOperatorHighlightPosition: self startPosition.
	super emitOperatorName: anOperatorNameStringOrCharacter.
	highlighter endOperatorHighlightPosition: self endPosition.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 4/3/2017 17:06'!
emitTypeTest: aNodeTest withNameTest: aNameTestString
	highlighter startFunctionCallHighlightPosition: self startPosition.
	self
		emitAll: aNodeTest nodeType name;
		emit: $(.
	highlighter endFunctionCallHighlightPosition: self endPosition.
	self emitAll: aNameTestString.
	highlighter startFunctionCallHighlightPosition: self startPosition.
	self emit: $).
	highlighter endFunctionCallHighlightPosition: self endPosition.
	^ aNodeTest! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 3/31/2017 04:44'!
endPosition
	^ stream position! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'accessing' stamp: 'monty 3/31/2017 04:41'!
highlighter
	^ highlighter! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'initialization' stamp: 'monty 3/31/2017 04:40'!
on: aStream
	super on: aStream.

	highlighter := XPathExpressionHighlighter new.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'private' stamp: 'monty 3/31/2017 04:43'!
startPosition
	^ stream position + 1! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 4/1/2017 23:23'!
visitArgument: anArgument
	super visitArgument: anArgument.
	highlighter startFunctionCallHighlightPosition: self startPosition.
	^ anArgument.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'visiting - functions' stamp: 'monty 3/31/2017 04:52'!
visitFunctionCall: aFunctionCall
	highlighter startFunctionCallHighlightPosition: self startPosition.
	super visitFunctionCall: aFunctionCall.
	highlighter endFunctionCallHighlightPosition: self endPosition.
	^ aFunctionCall.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 3/31/2017 04:52'!
visitNumberLiteral: aNumberLiteral
	highlighter startNumberLiteralHighlightPosition: self startPosition.
	super visitNumberLiteral: aNumberLiteral.
	highlighter endNumberLiteralHighlightPosition: self endPosition.
	^ aNumberLiteral.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'visiting - predicates' stamp: 'monty 4/2/2017 00:12'!
visitPredicate: aPredicate
	highlighter
		startPredicateHighlightPosition: self startPosition;
		endPredicateHighlightPosition: self startPosition;
		incrementPredicateColorLevel.
	super visitPredicate: aPredicate.
	highlighter
		decrementPredicateColorLevel;
		startPredicateHighlightPosition: self endPosition;
		endPredicateHighlightPosition: self endPosition.
	^ aPredicate.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'visiting - literals' stamp: 'monty 3/31/2017 04:52'!
visitStringLiteral: aStringLiteral
	highlighter startStringLiteralHighlightPosition: self startPosition.
	super visitStringLiteral: aStringLiteral.
	highlighter endStringLiteralHighlightPosition: self endPosition.
	^ aStringLiteral.! !

!XPathHighlightingASTSourceWritingNodeVisitor methodsFor: 'visiting - variables' stamp: 'monty 3/31/2017 04:52'!
visitVariableReference: aVariableReference
	highlighter startVariableReferenceHighlightPosition: self startPosition.
	super visitVariableReference: aVariableReference.
	highlighter endVariableReferenceHighlightPosition: self endPosition.
	^ aVariableReference.! !

!XPathASTFunctionCallNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 03:11'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathASTFunctionCallNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:21'!
supportsTreeView
	^ self hasArguments! !

!XPathASTFunctionCallNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:32'!
treeViewChildren
	^ self arguments! !

!XPathASTAttributeNodeTestForPrefixAndLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:31'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self localName qualifyWithXMLPrefix: self prefix);
		nextPut: $).! !

XMLHighlightDefaults subclass: #XPathExpressionHighlightDefaults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting'!

XPathExpressionHighlightDefaults class
	instanceVariableNames: 'defaultAxisColor defaultNodeTestColor defaultPredicateLevelOneColor defaultPredicateLevelTwoColor defaultPredicateLevelThreeColor defaultPredicateLevelFourColor defaultPredicateLevelFiveColor defaultPredicateLevelSixColor defaultOperatorColor defaultFunctionCallColor defaultStringLiteralColor defaultNumberLiteralColor defaultVariableReferenceColor'!

!XPathExpressionHighlightDefaults commentStamp: 'monty 3/1/2017 15:10' prior: 0!
This class stores the default highlight TextColors used by the XPath expression highlighter. It gets the initial defaults from Shout text styling.!

XPathExpressionHighlightDefaults class
	instanceVariableNames: 'defaultAxisColor defaultNodeTestColor defaultPredicateLevelOneColor defaultPredicateLevelTwoColor defaultPredicateLevelThreeColor defaultPredicateLevelFourColor defaultPredicateLevelFiveColor defaultPredicateLevelSixColor defaultOperatorColor defaultFunctionCallColor defaultStringLiteralColor defaultNumberLiteralColor defaultVariableReferenceColor'!

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:37'!
defaultAxisColor
	^ defaultAxisColor
		ifNil: [defaultAxisColor := self textColorForShoutProperty: #self]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:31'!
defaultAxisColor: aTextColor
	defaultAxisColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:42'!
defaultFunctionCallColor
	^ defaultFunctionCallColor
		ifNil: [defaultFunctionCallColor := self textColorForShoutProperty: #keyword].! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:47'!
defaultFunctionCallColor: aTextColor
	defaultFunctionCallColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:08'!
defaultNodeTestColor
	^ defaultNodeTestColor
		ifNil: [defaultNodeTestColor := self textColorForShoutProperty: #instVar]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:36'!
defaultNodeTestColor: aTextColor
	defaultNodeTestColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:30'!
defaultNumberLiteralColor
	^ defaultNumberLiteralColor
		ifNil: [defaultNumberLiteralColor := self textColorForShoutProperty: #number]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:41'!
defaultNumberLiteralColor: aTextColor
	defaultNumberLiteralColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:45'!
defaultOperatorColor
	^ defaultOperatorColor
		ifNil: [defaultOperatorColor := self textColorForShoutProperty: #binary]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:38'!
defaultOperatorColor: aTextColor
	defaultOperatorColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:33'!
defaultPredicateLevelFiveColor
	^ defaultPredicateLevelFiveColor
		ifNil: [
			defaultPredicateLevelFiveColor :=
				self textColorForShoutProperty: #blockStart5]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:33'!
defaultPredicateLevelFiveColor: aTextColor
	defaultPredicateLevelFiveColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:33'!
defaultPredicateLevelFourColor
	^ defaultPredicateLevelFourColor
		ifNil: [
			defaultPredicateLevelFourColor :=
				self textColorForShoutProperty: #blockStart4]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:33'!
defaultPredicateLevelFourColor: aTextColor
	defaultPredicateLevelFourColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:31'!
defaultPredicateLevelOneColor
	^ defaultPredicateLevelOneColor
		ifNil: [
			defaultPredicateLevelOneColor :=
				self textColorForShoutProperty: #blockStart1]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:31'!
defaultPredicateLevelOneColor: aTextColor
	defaultPredicateLevelOneColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:40'!
defaultPredicateLevelSixColor
	^ defaultPredicateLevelSixColor
		ifNil: [
			defaultPredicateLevelSixColor :=
				self textColorForShoutProperty: #blockStart6]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:40'!
defaultPredicateLevelSixColor: aTextColor
	defaultPredicateLevelSixColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:30'!
defaultPredicateLevelThreeColor
	^ defaultPredicateLevelThreeColor
		ifNil: [
			defaultPredicateLevelThreeColor :=
				self textColorForShoutProperty: #blockStart3]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/4/2017 22:08'!
defaultPredicateLevelThreeColor: aTextColor
	defaultPredicateLevelThreeColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:31'!
defaultPredicateLevelTwoColor
	^ defaultPredicateLevelTwoColor
		ifNil: [
			defaultPredicateLevelTwoColor :=
				self textColorForShoutProperty: #blockStart2]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 4/3/2017 18:31'!
defaultPredicateLevelTwoColor: aTextColor
	defaultPredicateLevelTwoColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:28'!
defaultStringLiteralColor
	^ defaultStringLiteralColor
		ifNil: [defaultStringLiteralColor := self textColorForShoutProperty: #string]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:41'!
defaultStringLiteralColor: aTextColor
	defaultStringLiteralColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 14:44'!
defaultVariableReferenceColor
	^ defaultVariableReferenceColor
		ifNil: [defaultVariableReferenceColor := self textColorForShoutProperty: #globalVar]! !

!XPathExpressionHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 3/1/2017 09:31'!
defaultVariableReferenceColor: aTextColor
	defaultVariableReferenceColor := aTextColor! !

!XPathExpressionHighlightDefaults class methodsFor: 'class initialization' stamp: 'monty 4/3/2017 18:40'!
initialize
	"self initialize"

	defaultDefaultColor := nil.
	defaultAxisColor := nil.
	defaultNodeTestColor := nil.
	defaultPredicateLevelOneColor := nil.
	defaultPredicateLevelTwoColor := nil.
	defaultPredicateLevelThreeColor := nil.
	defaultPredicateLevelFourColor := nil.
	defaultPredicateLevelFiveColor := nil.
	defaultPredicateLevelSixColor := nil.
	defaultOperatorColor := nil.
	defaultFunctionCallColor := nil.
	defaultStringLiteralColor := nil.
	defaultNumberLiteralColor := nil.
	defaultVariableReferenceColor := nil.! !

XPathExpressionHighlightDefaults initialize!

!XPathNamespaceNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/28/2017 05:35'!
supportsRemoveAction
	^ false! !

XPathNodeTestParser subclass: #XPathPositionNodeTestParser
	instanceVariableNames: 'startArgumentPosition endArgumentPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathPositionNodeTestParser commentStamp: 'monty 4/4/2017 08:03' prior: 0!
This is a node test parser that tracks the start and end positions of node tests and node type test arguments.!

!XPathPositionNodeTestParser methodsFor: 'accessing' stamp: 'monty 4/3/2017 17:37'!
currentPosition
	^ readStream position! !

!XPathPositionNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/4/2017 06:57'!
peekForNodeTest
	| startPosition |

	startPosition := self currentPosition + 1.
	startArgumentPosition := nil.
	endArgumentPosition := nil.
	super peekForNodeTest
		ifFalse: [^ false].

	handler handleStartNodeTestPosition: startPosition.
	isParsingNodeTypeTest
		ifTrue: [
			handler handleStartFunctionCallPosition: startPosition.
			startArgumentPosition
			ifNotNil: [
				handler
					handleStartArgumentPosition: startArgumentPosition;
					handleEndArgumentPosition: endArgumentPosition].
			handler handleEndFunctionCallPosition: self currentPosition].
	handler handleEndNodeTestPosition: self currentPosition.
	^ true.! !

!XPathPositionNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/4/2017 22:11'!
peekForNodeTestArgument
	| startPosition |
	
	startPosition := self currentPosition + 1.
	super peekForNodeTestArgument
		ifTrue: [
			startArgumentPosition := startPosition.
			endArgumentPosition := self currentPosition.
			^ true]
		ifFalse: [^ false].! !

!XPathPositionNodeTestParser methodsFor: 'parsing - peeking' stamp: 'monty 4/4/2017 22:11'!
peekForPITestTarget
	| startPosition |
	
	startPosition := self currentPosition + 1.
	super peekForPITestTarget
		ifTrue: [
			startArgumentPosition := startPosition.
			endArgumentPosition := self currentPosition.
			^ true]
		ifFalse: [^ false].! !

!XPathASTNamespaceTestForPrefixAndLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:30'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self localName qualifyWithXMLPrefix: self prefix);
		nextPut: $).! !

!XPathASTLocationPathNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:21'!
supportsTreeView
	^ self hasSteps! !

!XPathASTLocationPathNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:20'!
treeViewChildren
	^ self steps! !

!XPathASTNamespaceTestForNamespaceURINode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self namespaceURI;
		nextPut: $).! !

GLMXMLHighlighterTextStylerDecorator subclass: #GLMXPathHighlighterTextStylerDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!GLMXPathHighlighterTextStylerDecorator commentStamp: 'monty 3/31/2017 02:06' prior: 0!
A highlighting XPath expression text style decorator.!

GLMXPathHighlighterTextStylerDecorator subclass: #GLMXPathDisabledHighlighterTextStylerDecorator
	instanceVariableNames: 'disabledText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!GLMXPathDisabledHighlighterTextStylerDecorator commentStamp: 'monty 4/4/2017 08:04' prior: 0!
A disabled highlighting XPath expression text style decorator.!

!GLMXPathDisabledHighlighterTextStylerDecorator class methodsFor: 'instance creation' stamp: 'monty 4/3/2017 22:43'!
disabledText: aStringOrText
	^ self new disabledText: aStringOrText! !

!GLMXPathDisabledHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/3/2017 22:37'!
disabledText
	^ disabledText ifNil: [disabledText := '' asText]! !

!GLMXPathDisabledHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 4/3/2017 22:37'!
disabledText: aStringOrText
	disabledText := aStringOrText asText! !

!GLMXPathDisabledHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 4/3/2017 22:36'!
parse: aString onError: anError
	^ self disabledText! !

!GLMXPathHighlighterTextStylerDecorator methodsFor: 'private' stamp: 'monty 3/31/2017 15:30'!
highlightingParse: aString onSuccess: aOneArgumentBlock onError: aTwoArgumentBlock
	| highlightingParserHandler highlightingParser |

	highlightingParserHandler :=
		XPathHighlightingPositionExpressionParserHandler expressionSource:
			aString.
	highlightingParser :=
		XPathPositionExpressionParser
			on: aString
			for: highlightingParserHandler.
	[highlightingParser parse]
		on: XPathException
		do: [:error |
			"increment the position by one to more accurately reflect
			where the error happaned, because the parser peeks for each
			kind of token"
			^ aTwoArgumentBlock
				value: highlightingParserHandler
				value: highlightingParser currentPosition + 1].
	^ aOneArgumentBlock value: highlightingParserHandler.! !

!XPathASTNamespaceTestForLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self localName;
		nextPut: $).! !

!XPathASTAttributeNodeTestForNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathASTNamespaceTestForPrefixNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self prefix;
		nextPut: $).! !

!XPathASTAttributeNodeTestForNamespaceURINode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self namespaceURI;
		nextPut: $).! !

!XPathASTElementNodeTestForNamespaceURINode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self namespaceURI;
		nextPut: $).! !

!XPathASTNamespaceTestForNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathASTAttributeNodeTestForPrefixNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self prefix;
		nextPut: $).! !

!XPathASTNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 07:40'!
asHighlightedText
	^ XPathHighlightingASTSourceWritingNodeVisitor new
		visitNode: self;
		asHighlightedText! !

!XPathASTNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 4/3/2017 22:44'!
gtInspectorSourceIn: aComposite
	<gtInspectorPresentationOrder: 6>

	aComposite custom:
		(GLMXMLDisabledRubricHighlightedTextPresentation new
			title: 'Source';
			editingMode: [
				GLMHighlighterTextRubEditingMode withStylerDecorator:
					(GLMXPathDisabledHighlighterTextStylerDecorator
						disabledText: self asHighlightedText)];
			display: [self asHighlightedText];
			withLineNumbers: true)! !

!XPathASTNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 16:02'!
gtInspectorTreeIn: aComposite
	<gtInspectorPresentationOrder: 5>

	aComposite tree
		title: 'Tree';
		display: [{self}];
		children: [:each | each treeViewChildren];
		format: [:each | each treeViewLabelText];
		when: [self supportsTreeView];
		rootsExpanded! !

!XPathASTNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 03:11'!
printTreeViewLabelOn: aStream
	aStream nextPutAll: self class name asString! !

!XPathASTNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:24'!
supportsTreeView
	^ false! !

!XPathASTNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:12'!
treeViewChildren
	^ #()! !

!XPathASTNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 05:07'!
treeViewLabelText
	| writeStream |

	writeStream := (String new: 100) writeStream.
	self printTreeViewLabelOn: writeStream.
	^ writeStream contents asText.! !

!XMLDoctypeDeclaration methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/6/2017 17:50'!
supportsXPathEvaluator
	^ false! !

!XPathASTElementNodeTestForNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self name;
		nextPut: $).! !

!XPathASTBinaryOperatorExpressionNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 03:13'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self operatorName;
		nextPut: $).! !

!XPathASTNamespaceTestForNamespaceURIAndLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self localName expandWithXMLNamespaceURI: self namespaceURI);
		nextPut: $).! !

!XPathNodeTest class methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
generateASTTreeViewLabels
	"
	self generateASTTreeViewLabels
	"

	self allSubclasses
		select: [:each | each includesSelector: #printOn:]
		thenDo: [:each | | astNodeClass |
			astNodeClass :=
				XMLClassFinder classNamed:
					('XPathAST',
					(each name asString allButFirst: 'XPath' size),
					'Node') asSymbol.
			astNodeClass
				compile:
					((each sourceCodeAt: #printOn:)
						copyReplaceAll: 'printOn:'
						with: 'printTreeViewLabelOn:')
				classified: '*XPath-GTExtensions']! !

XPathExpressionParser subclass: #XPathPositionExpressionParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-GTExtensions-Highlighting-Parsers'!

!XPathPositionExpressionParser commentStamp: 'monty 3/1/2017 15:13' prior: 0!
This class is an XPath expression parser that tracks the start and end positions of certain XPath constructs.!

!XPathPositionExpressionParser methodsFor: 'accessing' stamp: 'monty 3/1/2017 10:37'!
currentPosition
	^ readStream position! !

!XPathPositionExpressionParser methodsFor: 'parsing' stamp: 'monty 4/1/2017 23:29'!
nextArgument
	handler handleStartArgumentPosition: self currentPosition + 1.
	super nextArgument.
	handler handleEndArgumentPosition: self currentPosition.! !

!XPathPositionExpressionParser methodsFor: 'parsing' stamp: 'monty 3/1/2017 15:44'!
nextFunctionCall
	handler handleStartFunctionCallPosition: self currentPosition + 1.
	super nextFunctionCall.
	handler handleEndFunctionCallPosition: self currentPosition.! !

!XPathPositionExpressionParser methodsFor: 'private' stamp: 'monty 4/3/2017 17:29'!
nodeTestParserClass
	^ XPathPositionNodeTestParser! !

!XPathPositionExpressionParser methodsFor: 'private' stamp: 'monty 4/3/2017 17:34'!
nodeTestParserHandlerClass
	^ XPathPositionExpressionNodeTestParserHandler! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 09:16'!
peekForAbbreviatedStep
	^ self
		peekWith: [super peekForAbbreviatedStep]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartAxisPosition: startPosition;
				handleEndAxisPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForAdditiveOperator
	^ self
		peekWith: [super peekForAdditiveOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForAndOperator
	^ self
		peekWith: [super peekForAndOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 14:27'!
peekForAxis
	^ self
		peekWith: [super peekForAxis]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartAxisPosition: startPosition;
				handleEndAxisPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:18'!
peekForEndPredicate
	super peekForEndPredicate
		ifTrue: [
			handler handleEndPredicatePosition: self currentPosition.
			^ true]
		ifFalse: [^ false]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:32'!
peekForEqualityOperator
	^ self
		peekWith: [super peekForEqualityOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForMultiplicativeOperator
	^ self
		peekWith: [super peekForMultiplicativeOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:31'!
peekForNegationOperator
	^ self
		peekWith: [super peekForNegationOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 10:47'!
peekForNumberLiteral
	^ self
		peekWith: [super peekForNumberLiteral]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartNumberLiteralPosition: startPosition;
				handleEndNumberLiteralPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:30'!
peekForOrOperator
	^ self
		peekWith: [super peekForOrOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:32'!
peekForRelationalOperator
	^ self
		peekWith: [super peekForRelationalOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:18'!
peekForStartPredicate
	super peekForStartPredicate
		ifTrue: [
			handler handleStartPredicatePosition: self currentPosition.
			^ true]
		ifFalse: [^ false]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:29'!
peekForStringLiteral
	^ self
		peekWith: [super peekForStringLiteral]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartStringLiteralPosition: startPosition;
				handleEndStringLiteralPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:32'!
peekForUnionOperator
	^ self
		peekWith: [super peekForUnionOperator]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartOperatorPosition: startPosition;
				handleEndOperatorPosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'parsing - peeking' stamp: 'monty 3/1/2017 08:28'!
peekForVariableReference
	^ self
		peekWith: [super peekForVariableReference]
		startAndEndPositionsDo: [:startPosition :endPosition |
			handler
				handleStartVariableReferencePosition: startPosition;
				handleEndVariableReferencePosition: endPosition]! !

!XPathPositionExpressionParser methodsFor: 'private' stamp: 'monty 3/1/2017 14:30'!
peekWith: aFirstBlock startAndEndPositionsDo: aSecondBlock
	| oldPosition |

	oldPosition := self currentPosition.
	aFirstBlock value
		ifTrue: [
			aSecondBlock
				cull: oldPosition + 1
				cull: self currentPosition.
			^ true]
		ifFalse: [^ false].! !

!XPathASTNodeWithOtherExpression methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 02:25'!
treeViewChildren
	^ Array
		with: self expression
		with: self otherExpression! !

!XPathASTAttributeNodeTestForNamespaceURIAndLocalNameNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/31/2017 04:28'!
printTreeViewLabelOn: aStream
	super printTreeViewLabelOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: (self localName expandWithXMLNamespaceURI: self namespaceURI);
		nextPut: $).! !

!XMLNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 4/13/2017 02:45'!
gtInspectorXPathIn: aComposite
	<gtInspectorPresentationOrder: 20>

	self supportsXPathEvaluator
		ifFalse: [^ self].

	aComposite custom:
		(GLMRubricHighlightedTextPresentation new
			title: 'XPath';
			editingMode: [
				GLMHighlighterTextRubEditingMode withStylerDecorator:
					GLMXPathHighlighterTextStylerDecorator new];
			display: [''];
			withLineNumbers: true;
			selectionAct: [:presentation |
				presentation
					selection:
						(self xpath: 
							(presentation selectedText asString
								ifEmpty: [presentation text asString]));
					clearUserEdits]
				on: $g
				entitled: 'Evaluate and go';
			act: [:presentation |
				presentation
					selection: (self xpath: presentation text asString);
					clearUserEdits]
				icon: GLMUIThemeExtraIcons glamorousGo
				on: $G
				entitled: 'Evaluate all and go').! !

!XMLNode methodsFor: '*XPath-GTExtensions' stamp: 'monty 3/6/2017 17:51'!
supportsXPathEvaluator
	^ true! !

XPathExpressionHighlightDefaults initialize!
